package com.izouma.wenlvju.web;

import com.izouma.wenlvju.domain.Person;
import com.izouma.wenlvju.service.PersonService;
import com.izouma.wenlvju.dto.PageQuery;
import com.izouma.wenlvju.exception.BusinessException;
import com.izouma.wenlvju.repo.PersonRepo;
import com.izouma.wenlvju.utils.ObjUtils;
import com.izouma.wenlvju.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/person")
@AllArgsConstructor
public class PersonController extends BaseController {
    private PersonService personService;
    private PersonRepo    personRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Person save(@RequestBody Person record) {
        if (record.getId() != null) {
            Person orig = personRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return personRepo.save(orig);
        }
        return personRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<Person> all(@RequestBody PageQuery pageQuery) {
        return personService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public Person get(@PathVariable Long id) {
        return personRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        personRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Person> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @PostMapping("/byPerApplyId")
    public List<Person> byPerApplyId(@RequestParam Long perApplyId) {
        return personRepo.findAllByPerformanceApplyId(perApplyId);
    }
}

